require 'time'
require 'log_analysis/version'

module DataMining
  class Error < StandardError; end
  # Your code goes here...

  def self.execute(transform_data, min_conf, min_sup)
    File.open(LogAnalysis::TRANSFORM_DATA_PATH, 'w+') { |f| transform_data.keys.each { |e| f.puts(transform_data[e].map { |i| i.is_a?(Array) ? i.join(' ') : i }.join(' -1 ').concat(' -1 -2')) } }
    system("java -jar #{LogAnalysis::JAR_FILE_PATH} run SPADE #{LogAnalysis::TRANSFORM_DATA_PATH} #{LogAnalysis::RULE_FILE_PATH} #{min_sup}%")
    rule_gen(get_seq(File.read(LogAnalysis::RULE_FILE_PATH)), min_conf)
  end

  def self.rule_gen(seqs, min_conf)
    seqs.each_with_object([]) { |seq, arr| seqs.each { |sub| arr.push([seq[0], sub[0], seq[1] / sub[1]]) if sub[0] != seq[0] && sub_seq?(sub[0], seq[0]) && seq[1] / sub[1] >= min_conf } }
  end

  def self.sub_seq?(first, second)
    ptr = 0
    first.each do |sub|
      return false if ptr >= second.size

      (ptr..second.size - 1).each do |n|
        if sub?(second[n], sub)
          ptr = n + 1
          break
        end
        return false if ptr == second.size - 1
      end
    end
    true
  end

  def self.sub?(str, sub)
    mark_sub = 0
    sub.split(' ').each { |char| mark_sub += 1 if str.include?(char) }

    mark_sub == sub.split(' ').size
  end

  def self.get_seq(seq_str)
    seq = seq_str.split("\n")
    seq.each_with_object([]) do |s, arr|
      split_seq = s.split('-1')
      arr.push([split_seq[0..-2], split_seq[-1][-1].to_f])
    end
  end
end
