require 'active_support/core_ext/numeric/time'
require 'log_analysis/model/session_identity'

module SessionIdentification
  MINUTE_THRESHOLD = 10

  class Error < StandardError; end
  # Your code goes here...

  def self.execute(identified_user)
    identified_user.each_with_object([]) do |user, arr|
      isession = arr.rindex { |s| s.user == user }
      user.records.each do |record|
        isession.present? && validate_time_session(arr[isession].records.last.time, record.time) ? arr[isession].records << record : arr << SessionIdentity.new(session_identity_params(record))
      end
    end
  end

  private

  def self.session_identity_params(record)
    {}.tap do |p|
      p[:user]    = record.user
      p[:records] = [record]
    end
  end

  def self.validate_time_session(last_session_record_time, time)
    (time - last_session_record_time) / 60 < MINUTE_THRESHOLD
  end
end
